
var show_record = 'no';

if(show_record != 'yes')
{
	document.getElementById('record').style.display = 'none';
}



window.onload = date_time('date_time')

function date_time(id)
{
        date = new Date;
        year = date.getFullYear();
        month = date.getMonth();
        months = new Array('January', 'February', 'March', 'April', 'May', 'June', 'Jully', 'August', 'September', 'October', 'November', 'December');
        d = date.getDate();
        day = date.getDay();
        days = new Array('Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday');
        h = date.getHours();
        if(h<10)
        {
                h = "0"+h;
        }
        m = date.getMinutes();
        if(m<10)
        {
                m = "0"+m;
        }
        s = date.getSeconds();
        if(s<10)
        {
                s = "0"+s;
        }
        result = 'Madrid, Spain <br /> '+days[day]+' '+months[month]+' '+d+' '+year+' '+h+':'+m+':'+s;
        document.getElementById(id).innerHTML = result;
        setTimeout('date_time("'+id+'");','1000');
        return true;
}

	var channel_max = 10;										// number of channels
	audiochannels = new Array();
	for (a=0;a<channel_max;a++) {									// prepare the channels
		audiochannels[a] = new Array();
		audiochannels[a]['channel'] = new Audio();						// create a new audio object
		audiochannels[a]['finished'] = -1;							// expected end time for this channel
	}
	function play_multi_sound(s) {
		for (a=0;a<audiochannels.length;a++) {
			thistime = new Date();
			if (audiochannels[a]['finished'] < thistime.getTime()) {			// is this channel finished?
				audiochannels[a]['finished'] = thistime.getTime() + document.getElementById(s).duration*1000;
				audiochannels[a]['channel'].src = document.getElementById(s).src;
				audiochannels[a]['channel'].load();
				audiochannels[a]['channel'].play();
				break;
			}
		}
	}

function getSkeletons(jsonObject) {
	var skl = 0;
  
  for (var i = 0; i < jsonObject.skeletons.length; i++) {
	var headZ = 0;
    var hipZ = 0;
	skl++;
    
    for (var j = 0; j < jsonObject.skeletons[i].joints.length; j++) 
    {
      
      var joint = jsonObject.skeletons[i].joints[j];
      //640 x 480

     var cordx = (joint.x * window.screen.availWidth) / 640;
     var cordy = (joint.y * window.screen.availHeight) / 480;
	 var cordz = 200 - ((joint.z * 200) / 4);
      
      if(joint.name == 'head')
      {
      document.getElementById('head' + skl).style.left = cordx + 'px';
      document.getElementById('head' + skl).style.top = cordy + 'px';
        document.getElementById('head' + skl).style.width = cordz + 'px';
        document.getElementById('head' + skl).style.height = cordz + 'px';
        document.getElementById('head' + skl).style.borderRadius  = cordz + 'px';
        document.getElementById('head' + skl).style.zIndex = Math.floor(cordz);

      }

      if(joint.name == 'handleft')
      {
      	document.getElementById('handleft' + skl).style.left = cordx + 'px';
      	document.getElementById('handleft' + skl).style.top = cordy + 'px';
        document.getElementById('handleft' + skl).style.width = cordz + 'px';
        document.getElementById('handleft' + skl).style.height = cordz + 'px';
        document.getElementById('handleft' + skl).style.borderRadius  = cordz + 'px';
        document.getElementById('handleft' + skl).style.zIndex = Math.floor(cordz);
      }

      if(joint.name == 'handright')
      {
      document.getElementById('handright' + skl).style.left = cordx + 'px';
      document.getElementById('handright' + skl).style.top = cordy + 'px';
        document.getElementById('handright' + skl).style.width = cordz + 'px';
        document.getElementById('handright' + skl).style.height = cordz + 'px';
        document.getElementById('handright' + skl).style.borderRadius = cordz + 'px';
         document.getElementById('handright' + skl).style.zIndex = Math.floor(cordz);
        
      }
      
      
      
      
      
    //http://www.codeproject.com/KB/dotnet/KinectGettingStarted/7.png
  //------------------------
  //[0] handright
  //[1] elbowright
  //[2] shoulderright
  //[3] handleft
  //[4] elbowleft
  //[5] shoulderleft
  //[6] head
  //[7] spineneck
  //[8] spinecenter
  //[9] hipcenter
  //[10] kneeleft
  //[11] kneeright
  //[12] ankleleft
  //[13] ankleright      
     }
	}
}

              
function msgFromArduino(value){
	console.debug('From Arduino: ' + value);
  
  var companyName = document.getElementById("companyName");
  var name = document.getElementById("name");
  
  var data = value.split("|");
  
  companyName.innerHTML=data[0];
  name.innerHTML=data[1];
  
  $('#companyName').addClass("fire_effect");
  
   if(data[0] == "MoodRobotics")
  {
    $('#name').removeClass("blue_effect");
  	$('#name').addClass("red_effect");  
    $.get('http://192.168.1.112/red.act', function(responseText) {
	});
  }
  else
  {
    $('#name').removeClass("red_effect");
    $('#name').addClass("blue_effect");
    $.get('http://192.168.1.112/blue.act', function(responseText) {
	});
  }
  
  
  
  setTimeout(function(){
  companyName.innerHTML="";
  name.innerHTML="";
    
  },7000);
  
  if(data[0] == "MoodRobotics")
  {
  	play_multi_sound('multiaudio4');

  }
  else
  {
  	play_multi_sound('multiaudio5');
	
  }
  
	setTimeout(function(){
	 $.get('http://192.168.1.112/off.act', function(responseText) {
    });
    },7000);
    
  
}

function next() {
	console.debug('Next!');  
}

function prior() {
	console.debug('Prior');
}

function grip() {
	console.debug('Grip!');  
}

function release() {
	console.debug('Release');
}

function noUser(){
  console.debug('No User :(');  
//sendToArduino('0');
  
}

function newUser() {
  console.debug('New User :)');  
  //sendToArduino('1');
}

function changeHandNone() {
	console.debug('Hand None');  
}

function changeHandRight() {
  	console.debug('Hand Right');  
}

function changeHandLeft() {
	console.debug('Hand Left');  
}



var recorder = function(){
    var containerId = "resultRecord";
  var debuggerId = "recordDebugger";
    var recording = false;
    var timeEnd = 0;
    var collection = [];
  var initialTime = 0;
    var toPlay = [];
    var times = 0;
  
	var startRecord = function(){
      collection = {};
       timeEnd = new Date().getTime()+initialTime;
       recorder.recording = true;
      setTimeout("recorder.stop()",initialTime);
    }
	var playRecord = function(){
      toPlay=[];
    	
      
      	
		if(recorder.times == 0 || recorder.times == undefined)
        {
          var e = document.getElementById("repetitions");
          recorder.times = e.options[e.selectedIndex].value - 1;
          console.log(recorder.times);
        }
        
         var toExec = JSON.parse(document.getElementById(containerId).value);
         var justNow = new Date().getTime();
          
          for (var key in toExec) {
              if(key<justNow){
                justNow=key;
              }
          }
         
          for (var key in toExec) {
            toPlay.push(toExec[key]);
             var refKey =  parseInt(key)-justNow;
             setTimeout(function(){
               console.log("exec");
              recorder.nextStep();
             }
               ,refKey);
          }
        
    }
    
    var nextStep = function(){
    	//if(toPlay[0]!=undefined){
      	if(toPlay.length > 0){
          getSkeletons(toPlay[0]);
          toPlay.shift();
          console.log(toPlay.length);
          console.log(recorder.times);
        }
      	
        if(toPlay.length == 0 && recorder.times > 0)
        {
         recorder.play();
		 recorder.times -= 1;
         console.log(recorder.times);
        }
      
    }
    var stopRecord = function(){

      printDebugger("STOPED");
      recorder.recording=false;
      document.getElementById(containerId).innerHTML=JSON.stringify(collection);
      timeEnd=0;
      collection = {};
    }
    var saveStep = function(jsonRef){
      	var actualDate = new Date().getTime();
        if(timeEnd<actualDate){
          //Ya termina de grabar
          stopRecord();
        }else{
        	collection[actualDate]=jsonRef;  
        }
    	
    }
    
    var printDebugger = function(texto){
      try{
    	document.getElementById(debuggerId).innerHTML=texto;
      }
      catch(err){
      }
    }
    var timeOut = function(initTime){
      initialTime=initTime;
      printDebugger(3);
      setTimeout(function(){
      	printDebugger(2);
        setTimeout(function(){
          printDebugger(1);
          setTimeout(function(){
            recorder.startRecord();
            printDebugger("RECORDING");
          },1000);
        },1000);
      },1000);
    }
    return{
      startRecord: startRecord,
     start: timeOut,
      play: playRecord,
      stop:stopRecord,
      saveStep:saveStep,
      recording:recording,
      timeEnd:timeEnd,
      collection:collection,
      nextStep:nextStep,
      timesValue: times,
      playArray:toPlay
    }
}()

